import objectdraw.*;
import java.awt.*;

public class WritingMethods extends FrameWindowController {
	private void makeSpot(Location point, double size) {
		point.translate(-.5 * size, -.5 * size);
		
		FramedOval oval = new FramedOval(point, size, size, Color.BLUE, canvas);
		oval.setLineWidth(.3 * size);
		
		FramedRect rect = new FramedRect(point, size, size, Color.RED, canvas);
		rect.setLineWidth(.1 * size);
	}
	
	public void onMouseMove(Location point) {
		this.makeSpot(point, 20);
	}
	
	public void onMouseDrag(Location point) {
		this.makeSpot(point, 30);
	}

	public static void main(String[] args) {
		new WritingMethods();
	}
}
