import objectdraw.*;
import java.awt.*;

public class RectangleDecorator extends FrameWindowController {
	Line line;
	
	public void onMousePress(Location point) {
		line = new Line(point, point, canvas);
	}
	
	public void onMouseDrag(Location point) {
		line.setEnd(point);
	}
	
	public void onMouseRelease(Location point) {
		FilledRect rect = new FilledRect(line.getStart(), line.getEnd(), canvas);
		decorate(rect);
		
		line.removeFromCanvas();
	}
	
	public void decorate(FilledRect rect) {
		Location corner = new Location(rect.getX() - 5, rect.getY() - 5);
		new FilledOval(corner, 10, 10, canvas);
		
		corner.translate(rect.getWidth(), 0);
		new FilledOval(corner, 10, 10, canvas);
		
		corner.translate(0, rect.getHeight());
		new FilledOval(corner, 10, 10, canvas);
		
		corner.translate(-rect.getWidth(), 0);
		new FilledOval(corner, 10, 10, canvas);
	}
	
	public static void main(String[] args) {
		new RectangleDecorator();
	}
}
