import objectdraw.*;
import java.awt.*;

public class PainterClient extends FrameWindowController implements ClientListener {
	Client network;
	
	public PainterClient() {
		super(600, 600, "Painter");
		Network.configure("Painter", new PainterServer(), this);
	}

	public void messageReceived(Client client, String message) {
		canvas.clear();
		
		for(String segment : message.split(";")) {
			Location loc = Code.decodeLocation(segment);
			new FilledRect(loc.getX() * 6, loc.getY() * 6, 6, 6, canvas);
		}
	}
	
	public void onMousePress(Location point) {
		if(network != null) {
			network.sendMessage(Code.encodeLocation(point));
		}
	}

	public void clientConnected(Client client) {
		network = client;
	}

	public void clientDisconnected(Client client) {
		network = null;
	}

	public static void main(String[] args) {
		new PainterClient();
	}
}
