import java.util.*;
import objectdraw.*;

public class PainterServer implements ServerListener {
	LinkedList<Location> paint;
	Server network;
	
	public void sendState() {
		String message = "";
		for(Location spot : paint) {
			message += Code.encodeLocation(spot) + ";";
		}
		
		if(message.length() > 0) network.sendMessage(message);
	}
	
	public boolean isOpen(Location loc) {
		Location found = null;
		
		for(Location spot : paint) {
			if(spot.getX() == loc.getX() && spot.getY() == loc.getY()) {
				found = spot;
			}
		}
		
		if(found != null) {
			paint.remove(found);
			return false;
		} else {
			return true;
		}
	}

	public void messageReceived(Server server, int channelID, String channelName, String message) {
		Location click = Code.decodeLocation(message);
		Location loc = new Location(click.getX() / 6, click.getY() / 6);
		if(isOpen(loc)) {
			paint.addLast(loc);
		}
	}

	public void serverStarted(Server server) {
		paint = new LinkedList<Location>();
		network = server;
		new EventTimer(this, "sendState").start(.1, .1);
	}

	public void serverStopped(Server server) { }
	
	public void channelClosed(Server server, int channelID, String channelName) { }

	public void channelOpened(Server server, int channelID, String channelName) { }
}
