import objectdraw.*;
import java.awt.*;
import fluids.*;

// More fun with timers
public class Pipes extends FrameWindowController {
	public Pipes() {
		super(862, 718, "Pipes");
	}
	
	public void begin() {
		Background background = new Background("pipes", canvas);
		
		Tank tank1 = new Tank("tank1", background);
		Tank tank2 = new Tank("tank2", background);
		Tank tank3 = new Tank("tank3", background);
		Tank tank4 = new Tank("tank4", background);
		
		Pipe pipe1 = new Pipe("pipe1", null, tank1, background);
		Pipe pipe2 = new Pipe("pipe2", tank1, tank2, background);
		Pipe pipe3 = new Pipe("pipe3", tank2, tank3, background);
		Pipe pipe4 = new Pipe("pipe4", tank2, tank4, background);
		
		manageFloat(new FilledRect(140, 180, 50, 50, Color.RED, canvas), tank1, .8);
		manageFloat(new FilledRect(290, 170, 40, 60, new Color(0xFF9900), canvas), tank1, .3);
		manageFloat(new FilledRect(400, 468, 80, 80, Color.YELLOW, canvas), tank2, .6);
		manageFloat(new FilledRect(760, 411, 30, 100, new Color(0x00AA00), canvas), tank4, .5);
		manageFloat(new FilledRect(130, 584, 100, 20, new Color(0x9900FF), canvas), tank3, .2);
		
		managePipe(pipe1, 0);
		managePipe(pipe2, 232);
		managePipe(pipe3, 550);
		managePipe(pipe4, 363);
	}
	
	public void managePipe(Pipe pipe, double inletLevel) {
		new EventTimer(this, "setFlowRate", pipe, inletLevel).start(.02, .02);
		new EventTimer(this, "moveWater", pipe).start(.02, .02);
	}
	
	public void manageFloat(FilledRect floater, Tank tank, double density) {
	}
	
	public void moveWater(Pipe pipe) {
		double volume = pipe.getFlowRate() * .00005;
		moveWater(pipe.getInlet(), -volume);
		moveWater(pipe.getOutlet(), volume);
	}
	
	public void moveWater(Tank tank, double volumeChange) {
		if(tank != null) {
			tank.setVolume(tank.getVolume() + volumeChange);
		}
	}
	
	public void setFlowRate(Pipe pipe, double minLevel) {
		double inletLevel = getWaterLevel(pipe.getInlet(), 0);
		double outletLevel = getWaterLevel(pipe.getOutlet(), canvas.getHeight());
		
		if(inletLevel > minLevel) {
			pipe.setFlowRate(0);
		} else {
			pipe.setFlowRate(100);
		}
	}
	
	public double getWaterLevel(Tank tank, double levelIfNull) {
		if(tank != null) {
			return tank.getWaterLevel();
		} else {
			return levelIfNull;
		}
	}
	
	public static void main(String[] args) {
		new Pipes();
	}
}