import objectdraw.*;
import java.awt.*;
import java.util.LinkedList;

public class TenSpots extends FrameWindowController {
	LinkedList<FilledOval> spots;
	Color color;
	
	public void begin() {
		spots = new LinkedList<FilledOval>();
		color = Color.RED;
	}
	
	public void onMousePress(Location point) {
		point.translate(-10, -10);
		spots.addLast(new FilledOval(point, 20, 20, color, canvas));
		
		if(spots.size() > 10) {
			FilledOval first = spots.removeFirst();
			first.removeFromCanvas();
		}
	}
	
	public void changeColor(Color newColor) {
		for(FilledOval oval : spots) {
			oval.setColor(newColor);
		}
		color = newColor;
	}
	
	public void onRPress() {
		changeColor(Color.RED);
	}
	
	public void onGPress() {
		changeColor(Color.GREEN);
	}
	
	public void onBPress() {
		changeColor(Color.BLUE);
	}
	
	public static void main(String[] args) {
		new TenSpots();
	}
}
