package objectdraw;

import java.util.HashSet;
import java.util.Iterator;
import java.util.LinkedList;

/**
 * @deprecated for internal use only
 * ObjectDrawObject is the superclass of everything that appears on the screen, as well as
 * Location. Its only job is to track when changes are made to an object and notify any 
 * other objects that use that one that they need to change.
 * 
 * @author Russell Zahniser (russell@zahniser.net)
 */
public class ObjectDrawObject implements Dependent {
	private static LinkedList notify = new LinkedList();
	private static boolean defer = false;
	
	HashSet dependents = new HashSet();
	
	/**
	 * @deprecated for internal use only
	 */
	public void depend(Dependent dependent) {
		if(dependent != null) dependents.add(dependent);
	}
	
	/**
	 * @deprecated for internal use only
	 */
	public void undepend(Dependent dependent) {
		if(dependent != null) dependents.remove(dependent);
	}
	
	/**
	 * @deprecated for internal use only
	 */
	public static void deferUpdates() {
		defer = true;
	}
	
	/**
	 * @deprecated for internal use only
	 */
	public static synchronized void runUpdates() {
		defer = false;
		for(int i = 0; i < notify.size(); i++) {
			((Dependent)notify.get(i)).update();
		}
		notify.clear();
	}
	
	/**
	 * @deprecated for internal use only
	 */
	private static synchronized void triggerUpdate(ObjectDrawObject object) {
		if(defer || notify.size() > 0) {
			Iterator iter = object.dependents.iterator();
			while(iter.hasNext()) {
				Dependent dependent = (Dependent)iter.next();
				if(!notify.contains(dependent)) {
					notify.addLast(dependent);
				}
			}
		} else {
			notify.addAll(object.dependents);
			runUpdates();
		}
	}
	
	/**
	 * @deprecated for internal use only
	 */
	public void update() {
		triggerUpdate(this);
	}
	
	/**
	 * @deprecated for internal use only
	 */
	protected String toString(String middle) {
		String name = getClass().getName();
		return "new " + name.substring(name.indexOf(".") + 1) + "(" + middle + ")";
	}
	
	public String toString() {
		return toString("");
	}
}
