package objectdraw;

import java.awt.Dimension;

import javax.swing.JPanel;

/**
 * <code>SizeablePanel</code> is a <code>JPanel</code> that allows you to set its size.
 * @author Russell Zahniser (russell@zahniser.net)
 */
public class SizeablePanel extends JPanel {
	private int width, height;
	
	/**
	 * Construct a <code>SizeablePanel</code> that will insist on being at least the given size.
	 * @param width Width of the panel
	 * @param height Height of the panel
	 */
	public SizeablePanel(int width, int height) {
		this.width = width;
		this.height = height;
	}
	
	public Dimension getPreferredSize() {
		return new Dimension(width, height);
	}
	
	public Dimension getMinimumSize() {
		return getPreferredSize();
	}
}
